routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index' );

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('/categories', 'CategoryController');

Route::resource('/types', 'TypeController');

Route::get('/preferences', 'PreferencesController@index')
		->name('preferences.index');
Route::get('/preferences/{preferences}/unit', 'PreferencesController@editUnit')
		->name('preferences.editUnit');
Route::put('/preferences/{preferences}/unit', 'PreferencesController@updateUnit')
		->name('preferences.updateUnit');

Route::resource('/widths', 'WidthsController');

Route::resource('/contacts', 'ContactsController');

// Actions Handled By Resource Controller

// Verb 		URI 					Action 		Route Name
// GET			/photos					index		photos.index
// GET			/photos/create 			create 		photos.create
// POST			/photos					store		photos.store
// GET			/photos/{photo}			show		photos.show
// GET			/photos/{photo}/edit	edit		photos.edit
// PUT/PATCH	/photos/{photo}			update		photos.update
// DELETE		/photos/{photo}			destroy		photos.destroy

app/Contacts.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Contacts extends Model
{
    //
    protected $fillable = [
		'user_id',
		'name',
		'title',
	];

	public function user()
	{
		return $this->belongsTo( User::class );
	}

	public function setNameAttribute( $value )
	{
		$this->attributes['name'] = ucwords( $value );
	}

	public function setTitleAttribute( $value )
	{
		$this->attributes['title'] = ucwords( $value );
	}
}

app/Http/Controllers/ContactsController.php
<?php

namespace App\Http\Controllers;

use App\Contacts;
use Illuminate\Http\Request;

class ContactsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $contacts = Contacts::orderBy('name')->get();

        return view('contacts.index', compact('contacts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('contacts.new');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Contacts  $contacts
     * @return \Illuminate\Http\Response
     */
    public function show(Contacts $contacts)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Contacts  $contacts
     * @return \Illuminate\Http\Response
     */
    public function edit(Contacts $contacts)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Contacts  $contacts
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Contacts $contacts)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Contacts  $contacts
     * @return \Illuminate\Http\Response
     */
    public function destroy(Contacts $contacts)
    {
        //
    }
}

resources/views/contacts/edit.blade.php
@extends('layouts.app')

@section('pageTitle', 'Edit Film Type')

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('types.index') }}">Film Types</a></li>
		<li class="breadcrumb-item active">Edit Film Type</li>
	</ol>

@endsection

@section('content')

	<h1>Edit Film Type</h1>

	<form action="{{ route('types.update', $type->id) }}" method="POST">
		{{ csrf_field() }}
		{{ method_field('PATCH') }}
		<fieldset class="form-group{{ $errors->has('category') ? ' has-danger' : '' }}">
			<label for="filmTypeCategory" class="form-control-label">Film Category</label>
			<select name="category"	class="form-control" id="filmTypeCategory">
				@foreach ($categories as $category)
					<option value="{{ $category->id }}" {{ old('category', $type->category_id) == $category->id ? ' selected' : '' }}>
						{{ $category->name }}
					</option>
				@endforeach
			</select>
			<small class="form-control-feedback">
				Required. Please select which Film Category applies to this Film Type.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
			<label for="filmTypeName" class="form-control-label">Film Type Name</label>
			<input 	type="text"
					name="name"
					required="true"
					autocomplete="off" 
					class="form-control"
					id="filmTypeName"
					placeholder="Ex: 121 Etch; Frosted Sandblast"
				value="{{ old('name', $type->name) }}">
			<small class="form-control-feedback">
				Required. Must be unique.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('abbreviation') ? ' has-danger' : '' }}">
			<label for="filmAbbreviationName" class="form-control-label">Film Type Abbreviation</label>
			<input 	type="text"
					name="abbreviation"
					required="true"
					autocomplete="off"
					class="form-control"
					id="filmAbbreviationName"
					placeholder="Ex: 121E; WE; R208MIL"
					value="{{ old('abbreviation', $type->abbreviation) }}"
					minlength="1"
					maxlength="7">
			<small class="form-control-feedback">
				Required. Between 1 and 7 Alpha-Numeric characters only; must be unique.
			</small>
			<small class="text-muted">
				 The abbreviation is incorporated in the identification number used on film rolls entered in inventory. This way, your film rolls are easily identifiable, even just by looking at the roll number.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('description') ? ' has-danger' : '' }}">
			<label for="filmTypeDescription" class="form-control-label">Film Type Description</label>
			<textarea name="description" class="form-control" id="filmTypeDescription" placeholder="Ex: Etch has an etched glass finish.">{{ old('description', $type->description) }}</textarea>
			<small class="form-control-feedback">
				Optional. Between 2 and 200 characters.
			</small>
		</fieldset>
		<fieldset class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Save
			</button>
			<a href="{{ route('types.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</fieldset>
	</form>

@endsection

resources/views/contacts/index.blade.php
@extends( 'layouts.app' )

@section( 'pageTitle', 'View Contacts' )

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item active">Contacts</li>
	</ol>

@endsection

@section( 'content' )
	<h1>View Contacts</h1>

	<p>
		<a href="{{ route('contacts.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Contact
		</a>
	</p>

	<div class="card-columns">
		
		@foreach ($contacts as $contact)
		
		<div class="card">

			<div class="card-block">

				<h4 class="card-title h5">
					<a href="{{ route( 'contacts.show', $contact->id ) }}">
						{{ $contact->name }}
					</a>
				</h4>

				<p class="text-muted">
					<span class="fa fa-id-card"></span>
					<abbr title="The Contact's Title">
						{{ $contact->title }}
					</abbr>
				</p>
			</div>

			<div class="card-footer">
				<form id="deleteForm{{ $contact->id }}" action="{{ route( 'contacts.destroy', $contact->id ) }}" method="POST">
					{{ csrf_field() }}
					{{ method_field('DELETE') }}


					<div class="form-group">
						<a href="{{ route('contacts.edit', $contact->id) }}" class="btn btn-secondary btn-block btn-sm">
							<span class="fa fa-pencil"></span>
							Edit
						</a>
					</div>

					<div class="form-group">
						<button type="button" class="btn btn-outline-danger btn-block btn-sm" data-toggle="modal" data-target="#deleteConfirmModal" data-id="{{ $contact->id }}">
							<span class="fa fa-trash"></span> 
							Delete
						</button>
					</div>
					
				</form>
				
			</div>
		</div>
		@endforeach
	</div>

	@if ( $contacts->count() < 1 )
	<p>
		There are no Film Types to display.
	</p>
	@endif

	<p>
		<a href="{{ route('contacts.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Film Type
		</a>
	</p>
 	
	<div class="modal fade" id="deleteConfirmModal" tabindex="-1" role="dialog" aria-labelledby="deleteConfirmModalLabel" aria-hidden="true">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="deleteConfirmModalLabel">Are you sure?</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<p>
						Do you really want to delete this item?
					</p>
				<div class="modal-footer">

					<button id="btnModalConfirm" type="button" class="btn btn-primary">Yes</button>
					<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>

				</div>
			</div>
		</div>
	</div>
@endsection

@section('pageScript')
	<script type="text/javascript">
		$('#deleteConfirmModal').on('show.bs.modal', function (event) {
			var button = $(event.relatedTarget); // Button that triggered the modal
			var contactId = button.data('id'); // Extract info from data-* attributes
			// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
			// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
			// var modal = $(this);

			$('#btnModalConfirm').click( function() {

				var modal = $('.modal');
				
				modal.modal('hide');

				$('#deleteForm' + contactId).submit();

			});

		})
	</script>
@endsection

resources/views/contacts/new.blade.php
@extends('layouts.app')

@section('pageTitle', 'New Film Type')

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('types.index') }}">Film Types</a></li>
		<li class="breadcrumb-item active">New Film Type</li>
	</ol>

@endsection

@section('content')

	<h1>New Film Type</h1>

	<form action="{{ route('types.store') }}" method="POST">
		{{ csrf_field() }}
		<fieldset class="form-group{{ $errors->has('category') ? ' has-danger' : '' }}">
			<label for="filmTypeCategory" class="form-control-label">Film Category</label>
			<select name="category"	class="form-control" id="filmTypeCategory">
				<option value="0" {{ old('category') == 0 ? ' selected' : '' }}>
					Please Select Category...
				</option>
				@foreach ($categories as $category)
					<option value="{{ $category->id }}" {{ old('category') == $category->id ? ' selected' : '' }}>
						{{ $category->name }}
					</option>
				@endforeach
			</select>
			<small class="form-control-feedback">
				Required. Please select which Film Category applies to this Film Type.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
			<label for="filmTypeName" class="form-control-label">Film Type Name</label>
			<input 	type="text"
					name="name"
					required="true"
					autocomplete="off" 
					class="form-control"
					id="filmTypeName"
					placeholder="Ex: 121 Etch; Frosted Sandblast"
				value="{{ old('name') }}">
			<small class="form-control-feedback">
				Required. Must be unique.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('abbreviation') ? ' has-danger' : '' }}">
			<label for="filmAbbreviationName" class="form-control-label">Film Type Abbreviation</label>
			<input 	type="text"
					name="abbreviation"
					required="true"
					autocomplete="off"
					class="form-control"
					id="filmAbbreviationName"
					placeholder="Ex: 121E; WE; R208MIL"
					value="{{ old('abbreviation') }}"
					minlength="1"
					maxlength="7">
			<small class="form-control-feedback">
				Required. Between 1 and 7 Alpha-Numeric characters only; must be unique.
			</small>
			<small class="text-muted">
				 The abbreviation is incorporated in the identification number used on film rolls entered in inventory. This way, your film rolls are easily identifiable, even just by looking at the roll number.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('description') ? ' has-danger' : '' }}">
			<label for="filmTypeDescription" class="form-control-label">Film Type Description</label>
			<textarea name="description" class="form-control" id="filmTypeDescription" placeholder="Ex: Etch has an etched glass finish.">{{ old('description') }}</textarea>
			<small class="form-control-feedback">
				Optional. Between 2 and 200 characters.
			</small>
		</fieldset>
		<fieldset class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Save
			</button>
			<a href="{{ route('types.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</fieldset>
	</form>

@endsection